---
title: "Apprenez à contrôler vim"
date: 2020-07-29T06:47:30+02:00
author: "Romain de Laage"
tags: ["vim", "éditeur", "UNIX", "POSIX"]
keywords: ["vim", "éditeur", "UNIX", "POSIX"]
draft: false
---

# Apprenez à contrôler vim

J'ai pendant longtemps utilisé [gedit](https://wiki.gnome.org/Apps/Gedit) pour éditer mes fichiers source/de configuration/texte, lorsque j'avais besoin de les éditer en tant qu'administrateur je lançais un simple `sudo gedit` ou alors j'utilisais le fameux [nano](https://www.nano-editor.org/), un éditeur qui s'utilise directement dans le terminal et qui est vraiment très simple d'utilisation pour un usage basique. J'utilisais aussi nano lorsqu'il s'agissait d'éditer des fichiers à distance en ssh au lieu d'utiliser un mastodon comme sshfs pour éditer avec gedit depuis mon poste.

Cependant, autant je n'ai pas de problème avec gedit qui est assez puissant et confortable avec les bons paramètres et les bons plugins, autant j'ai plus de mal avec nano qui n'a finalement que des fonctionnalités basiques afin de rester simple. Il n'y a aucun support des extensions et les seuls paramètres personnalisables sont assez basiques (comme la coloration syntaxique, la numérotation des lignes, ...). J'avais déjà testé vim à mes tout débuts sur linux car il était installé par défaut sur ma distribution et j'en avais entendu pas mal de bien, cependant j'avais été assez frustré par la difficulté lors de l'usage de cet éditeur qui semble moins standard que les autres avant de le redécouvrir récemment.

Vim est un acronyme pour *Vi Improved* (version améliorée de Vi), lui Vi est un éditeur assez fameux pour l'histoire de la [guerre des éditeurs](https://fr.wikipedia.org/wiki/Guerre_d%27%C3%A9diteurs), il est installé sur la plupart des distributions GNU/Linux tout comme nano. C'est un éditeur qui fait déjà tout ce que fait nano mais qui a des fonctionnalités plus poussées comme l'exécution de commandes, le split de l'écran pour regarder plusieurs fichiers, le supports des extensions, ... Il est développé à un tel point que des solutions existent pour en faire un vertible [IDE dans un terminal](https://spacevim.org/), certains diront que c'est un peu *too much* mais ça a le mérite d'exister. Le gros avantage de Vim c'est le fait d'être un éditeur avancé directement disponible dans une console en SSH ou sur un poste sans environnement graphique, il a en plus le gros avantage d'être vraiment très léger.

J'ai longtemps repoussé cette alternative à nano car ma première expérience avec a été assez frustrante (je ne savais même pas comment sortir de ce machin) puis je l'ai redécouvert, en m'ennuyant durant ces vacances d'été, par une suggestion de vidéo sur YouTube (honte à moi de traîner sur les services de Google). J'ai alors appris à utiliser les bases de vim, puis j'ai découvert la commande `vimtutor` qui propose d'apprendre vim par la pratique (c'est installé par défaut avec vim sur Fedora, à voir sur les autres distribs) et je dois avouer que c'est ce qui m'a convaincu. On m'a aussi fait découvrir [ce site](https://vim-adventures.com/) qui propose d'apprendre vim par le jeu, ça semble aussi être une bonne idée mais c'est assez vite très limité par le fait qu'il faille acheter une licence pour continuer, c'est surement plus destiné aux entreprises désireuses de faire découvrir les avantages de vim à leurs employés afin de gagner en productivité.

Finalement je suis passé à vim en tant qu'éditeur principal (sans pour autant renier gedit pour le plaisir des yeux quand il s'agit d'un simple texte), il permet vraiment de gagner du temps quand on le connaît et il est également très confortable car il utilise finalement assez peu les touches modificatrices (Ctrl ou Alt).
